﻿using System;
using System.Diagnostics;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

class Program
{
    static void Main(string[] args)
    {
        Log("Main");
        DebugLog("Main");

        MessageBox(IntPtr.Zero, "message", "title", 0);

        [SkipLocalsInit]
        void Log([DummyParam] string text)
        {
            int tid = Thread.CurrentThread.ManagedThreadId;
            string logText = $"[{tid}-{args.Length}] {text}";

            Console.WriteLine(logText);
        }

        [Conditional("DEBUG")]
        static void DebugLog(string text)
        {
            // A static local function cannot contain a reference to 'args'
            // Console.WriteLine($"[{args.Length}] DEBUG: " + text);

            Console.WriteLine("DEBUG: " + text);
        }

        [DllImport("User32.dll", CharSet = CharSet.Unicode)]
        static extern int MessageBox(IntPtr h, string m, string c, int type);
    }
}

[AttributeUsage(AttributeTargets.Parameter)]
public sealed class DummyParamAttribute : Attribute
{
}

#if !NET5_0
namespace System.Runtime.CompilerServices
{
    [AttributeUsage(AttributeTargets.Module | AttributeTargets.Class | AttributeTargets.Struct | AttributeTargets.Constructor | AttributeTargets.Method | AttributeTargets.Property | AttributeTargets.Event | AttributeTargets.Interface, Inherited = false)]
    public sealed class SkipLocalsInitAttribute : Attribute
    {
    }
}
#endif